/* Fakiir
 *
 * (C) Copyright 2005 Denis Rojo <jaromil@dyne.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * "$Id: $"
 *
 */

#include <iostream>
#include <stdio.h>
#include <unistd.h>

#include <config.h>
#include <fakiir.h>
#include <semantics.h>
#include <utils.h>

extern int yylex();
extern FILE *yyin;

extern Object_map *treesort();
extern void treegen(Object_map *symbols, char *filename);

int main(int argc, char **argv) {
  Object_map *syms;

  N("%s - a programmer's tool for RPC code generation",
    PACKAGE_NAME);
  A("fakiir.dyne.org - by Denis Rojo aka jaromil@dyne.org");

  if( argc <2) {
    E("usage: fakiir header_file");
    exit(1);
  }
  
  yyin = fopen(argv[1],"r");

  N("processing header file %s",argv[1]);
  
  yylex();
  
  syms = treesort();
  
  A("tree of %i parents formed",syms->size());
  
  treegen( syms, argv[1] );
  
  exit(0);
}
 
