/* Fakiir
 *
 * (C) Copyright 2005 Denis Rojo <jaromil@dyne.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __DAEMONS_H__
#define __DAEMONS_H__

#include <pthread.h>

#include <fakiir.h>

#include <xmlrpc/XmlRpc.h>
#include <lo/lo.h>

using namespace XmlRpc;

class Srv_XmlRpc {
 public:
  Srv_XmlRpc(Fakiir *fak);
  ~Srv_XmlRpc();  

  bool start(int port);
  void stop();

  bool running;
  bool quit;

  Fakiir *fakiir;

  XmlRpcServer *srv;
  
 private:
  pthread_t _thread;
  pthread_attr_t _attr;

};



class Srv_Osc {
 public:
  Srv_Osc(Fakiir *fak);
  ~Srv_Osc();

  bool start(int port);
  void stop();
  
  bool running;

  Fakiir *fakiir;

  lo_server_thread srv;
};



#endif
